我是靠谱客的博主 温婉路人,最近开发中收集的这篇文章主要介绍LeetCode-Python-1177. 构建回文串检测,觉得挺不错的,现在分享给大家,希望可以做个参考。

概述

给你一个字符串 s,请你对 s 的子串进行检测。

每次检测,待检子串都可以表示为 queries[i] = [left, right, k]。我们可以 重新排列 子串 s[left], ..., s[right],并从中选择 最多 k 项替换成任何小写英文字母。 

如果在上述检测过程中,子串可以变成回文形式的字符串,那么检测结果为 true,否则结果为 false

返回答案数组 answer[],其中 answer[i] 是第 i 个待检子串 queries[i] 的检测结果。

注意:在替换时,子串中的每个字母都必须作为 独立的 项进行计数,也就是说,如果 s[left..right] = "aaa" 且 k = 2,我们只能替换其中的两个字母。(另外,任何检测都不会修改原始字符串 s,可以认为每次检测都是独立的)

 

示例:

输入:s = "abcda", queries = [[3,3,0],[1,2,0],[0,3,1],[0,3,2],[0,4,1]]
输出:[true,false,false,true,true]
解释:
queries[0] : 子串 = "d",回文。
queries[1] : 子串 = "bc",不是回文。
queries[2] : 子串 = "abcd",只替换 1 个字符是变不成回文串的。
queries[3] : 子串 = "abcd",可以变成回文的 "abba"。 也可以变成 "baab",先重新排序变成 "bacd",然后把 "cd" 替换为 "ab"。
queries[4] : 子串 = "abcda",可以变成回文的 "abcba"。

 

提示:

  • 1 <= s.length, queries.length <= 10^5
  • 0 <= queries[i][0] <= queries[i][1] < s.length
  • 0 <= queries[i][2] <= s.length
  • s 中只有小写英文字母

第一种思路:

暴力解,把每次查询的子串都找出来,

然后写个辅助函数计算把这个子串变成回文子串需要的操作个数为多少,然后将实际所需的操作数和给定的操作数k比较即可。

怎么写这个辅助函数?

先用counter找到每个字母的出现频率,

如果一个字母的出现频率是偶数次,那么这个字母是很ok,不用管它;

如果一个字母的出现频率是奇数次,那么需要处理它,

统计一下子串里一共有多少个字母出现了奇数次odd_cnt,

然后就可以知道要把这个子串变成回文子串需要的操作数为 odd_cnt // 2。

举例 "abc" 可以变成"aba", odd_cnt = 3, 操作数为 3//2 = 1

再举例 "abcd" 可以变成 "abba", odd_cnt = 4, 操作数为 4//2 = 2

然而Python太慢了,会超时,C++似乎可以过……

class Solution(object):
def canMakePaliQueries(self, s, queries):
"""
:type s: str
:type queries: List[List[int]]
:rtype: List[bool]
"""
res = []
for left, right, k in queries:
if self.helper(s[left:right + 1], k):
res.append(True)
else:
res.append(False)
return res
def helper(self, word, k):
dic = collections.Counter(word)
odd_cnt = 0
for char, freq in dic.items():
if freq % 2:
odd_cnt += 1
return odd_cnt // 2 <= k

第二种思路:

小优化一下,每个子串的长度是已知的,为l =  right - left + 1, 那么只要 k >= l // 2, 那么肯定可以变成回文子串。

然而Python还是超时……

class Solution(object):
def canMakePaliQueries(self, s, queries):
"""
:type s: str
:type queries: List[List[int]]
:rtype: List[bool]
"""
res = []
for left, right, k in queries:
if k >= (right - left + 1 // 2) or self.helper(s[left:right + 1], k):
res.append(True)
else:
res.append(False)
return res
def helper(self, word, k):
dic = collections.Counter(word)
odd_cnt = 0
for char, freq in dic.items():
if freq % 2:
odd_cnt += 1
return odd_cnt // 2 <= k

第三种思路:

继续优化,

已知子串全部由小写字母组成,那么最多有多少个字母出现了奇数次呢?

答案是26个字母,所以只要 k 比 26的一半也就是13 大,那么必定可以将子串变成回文子串。

这回终于能过了……

class Solution(object):
def canMakePaliQueries(self, s, queries):
"""
:type s: str
:type queries: List[List[int]]
:rtype: List[bool]
"""
res = []
for left, right, k in queries:
if k >= 13 or self.helper(s[left:right + 1], k):
res.append(True)
else:
res.append(False)
return res
def helper(self, word, k):
dic = collections.Counter(word)
odd_cnt = 0
for char, freq in dic.items():
if freq % 2:
odd_cnt += 1
return odd_cnt // 2 <= k

第四种思路:

第一种思路为啥特别容易超时呢,因为对于每个子串都要遍历一遍,

假设查询k次,那么总的时间复杂度就是 O(kN),而k最大值是N, 相当于 O(N^2),

对于10^5的数据来说,O(N^2)是不行的……

所以可以考虑这么优化,对于每个子串不再遍历,而是利用出现次数的前缀和数组直接计算每个子串里的字母出现的次数,

这样可以大大加快运行速度。

class Solution(object):
def canMakePaliQueries(self, s, queries):
"""
:type s: str
:type queries: List[List[int]]
:rtype: List[bool]
"""
alphabet = set(s) #无需处理26个字母,只需处理在s中出现过的字母
dic = dict()
for char in alphabet:
dic[char] = [0 for _ in range(len(s))]
for i, ch in enumerate(s): #计算出现次数的前缀和
for char in alphabet:
if ch == char:
if i > 0:
dic[ch][i] = dic[ch][i - 1] + 1
else:
dic[ch][i] = 1
else:
if i > 0:
dic[char][i] = dic[char][i - 1]
res = []
for left, right, k in queries:
odd_cnt = 0
for char in alphabet:
if left > 0:
if (dic[char][right] - dic[char][left - 1]) % 2 == 1:# 直接相减得到字母出现次数
odd_cnt += 1
else:
if dic[char][right] % 2 == 1:
odd_cnt += 1
if odd_cnt // 2 <= k:
res.append(True)
else:
res.append(False)
return res

 

最后

以上就是温婉路人为你收集整理的LeetCode-Python-1177. 构建回文串检测的全部内容,希望文章能够帮你解决LeetCode-Python-1177. 构建回文串检测所遇到的程序开发问题。

如果觉得靠谱客网站的内容还不错,欢迎将靠谱客网站推荐给程序员好友。

本图文内容来源于网友提供,作为学习参考使用,或来自网络收集整理,版权属于原作者所有。
点赞(38)

评论列表共有 0 条评论

立即
投稿
返回
顶部